import matplotlib.pyplot as plt
import numpy as np
import math

def rpmtorads(rpm):
    return rpm/60*2*math.pi

scale = 1000
ratio = 14
r_eff = 0.7

RE25_57w = 5050
RE25_57t = 129
RE25_57nlA = 8.52/1000
RE25_57Tnom = 30
RE25_56w = 8240
RE25_56t = 209
RE25_56nlA = 15.2/1000
RE25_56Tnom = 28.7
RE25_49w = 10000
RE25_49t = 264
RE25_49nlA = 110/1000
RE25_49Tnom = 11.1

fig, (ax1,ax2,ax3)= plt.subplots(1,3,figsize=(18,6))

RE25_57_Kem = 89.6
RE25_57_Ksp = 107
RE25_57_Unom = 48
RE25_56_Kem = 55
RE25_56_Ksp = 174
RE25_56_Unom = 48
RE25_49_Kem = 7.96
RE25_49_Ksp = 1200
RE25_49_Unom = 9

# """
# TEST FOR RE25 118757
#############################################################
x_lim = 5100
y_lim = 150
p_lim = RE25_57t/RE25_57_Kem*RE25_57_Unom
w = np.linspace(0,RE25_57w,scale)
RE25_57T = np.linspace(RE25_57t,0,scale)
RE25_57I = np.linspace(RE25_57t/RE25_57_Kem,RE25_57nlA,scale)
RE25_57nom = [RE25_57Tnom] * scale
RE25_57nomr = [RE25_57Tnom*ratio*r_eff] * scale
RE25_57Pel = RE25_57I*RE25_57_Unom
RE25_57Pas = RE25_57T/1000*rpmtorads(w)
RE25_57Ploss = RE25_57Pel-RE25_57Pas
RE25_57Eff = (RE25_57Pas/RE25_57Pel)*100
ax1.plot(w,RE25_57T,label="xx57")
ax2.plot(w/ratio,RE25_57T*ratio*r_eff,label="xx57r")
ax1.plot(w,RE25_57nom,label="xx57nom")
ax2.plot(w,RE25_57nomr,label="xx57nomr")
ax3.plot(w,RE25_57Pel,label="P electrical")
ax3.plot(w,RE25_57Pas,label="P mechanical")
ax3.plot(w,RE25_57Ploss,label="P loss")
ax4 = ax1.twinx()
ax4.plot(w,RE25_57Eff,label="Efficiency",color='C9')
ax5 = ax2.twinx()
ax5.plot(w/ratio,RE25_57Eff,label="Efficiency ratio'd",color='C8')
ax6 = ax3.twinx()
ax6.plot(w,RE25_57Eff,label="Efficiency",color='C9')
# """

"""
# TEST FOR RE25 118756
#############################################################
x_lim = 8300
y_lim = 210
p_lim = RE25_56t/RE25_56_Kem*RE25_56_Unom
w = np.linspace(0,RE25_56w,scale)
RE25_56T = np.linspace(RE25_56t,0,scale)
RE25_56I = np.linspace(RE25_56t/RE25_56_Kem,RE25_56nlA,scale)
RE25_56nom = [RE25_56Tnom] * scale
RE25_56nomr = [RE25_56Tnom*ratio*r_eff] * scale
RE25_56Pel = RE25_56I*RE25_56_Unom
RE25_56Pas = RE25_56T/1000*rpmtorads(w)
RE25_56Ploss = RE25_56Pel-RE25_56Pas
RE25_56Eff = (RE25_56Pas/RE25_56Pel)*100
ax1.plot(w,RE25_56T,label="xx56")
ax2.plot(w/ratio,RE25_56T*ratio*r_eff,label="xx56r")
ax1.plot(w,RE25_56nom,label="xx56nom")
ax3.plot(w,RE25_56Pel,label="P electrical")
ax3.plot(w,RE25_56Pas,label="P mechanical")
ax3.plot(w,RE25_56Ploss,label="P loss")
ax4 = ax1.twinx()
ax4.plot(w,RE25_56Eff,label="Efficiency",color='C9')
ax5 = ax2.twinx()
ax5.plot(w/ratio,RE25_56Eff,label="Efficiency ratio'd",color='C8')
ax6 = ax3.twinx()
ax6.plot(w,RE25_56Eff,label="Efficiency",color='C9')
# """

"""
# TEST FOR RE25 118749
#############################################################
x_lim = 10500
y_lim = 280
p_lim = RE25_49t/RE25_49_Kem*RE25_49_Unom
w = np.linspace(0,RE25_49w,scale)
RE25_49T = np.linspace(RE25_49t,0,scale)
RE25_49I = np.linspace(RE25_49t/RE25_49_Kem,RE25_49nlA,scale)
RE25_49nom = [RE25_49Tnom] * scale
RE25_49nomr = [RE25_49Tnom*ratio*r_eff] * scale
RE25_49Pel = RE25_49I*RE25_49_Unom
RE25_49Pas = RE25_49T/1000*rpmtorads(w)
RE25_49Ploss = RE25_49Pel-RE25_49Pas
RE25_49Eff = (RE25_49Pas/RE25_49Pel)*100
ax1.plot(w,RE25_49T,label="xx49")
ax2.plot(w/ratio,RE25_49T*ratio*r_eff,label="xx49r")
ax1.plot(w,RE25_49nom,label="xx49nom")
ax2.plot(w,RE25_49nomr,label="xx49nomr")
ax3.plot(w,RE25_49Pel,label="P electrical")
ax3.plot(w,RE25_49Pas,label="P mechanical")
ax3.plot(w,RE25_49Ploss,label="P loss")
ax4 = ax1.twinx()
ax4.plot(w,RE25_49Eff,label="Efficiency",color='C9')
ax5 = ax2.twinx()
ax5.plot(w/ratio,RE25_49Eff,label="Efficiency ratio'd",color='C8')
ax6 = ax3.twinx()
ax6.plot(w,RE25_49Eff,label="Efficiency",color='C9')
# """

T_2a = [18.28125] * scale
T_2b = [116.62425 ] * scale
T_2c = [51.95475 ] * scale
T_1a = [79.72875] * scale #Absolute waarde, is eig. negatief
T_3a = [45.37125] * scale

# ax1.plot(w,T_1a,label="T_1a",linestyle=(0,(3,1,1,1)))
# ax1.plot(w,T_1b,label="T_1b",linestyle=(0,(3,1,1,1)))
# ax1.plot(w,T_1c,label="T_1c",linestyle=(0,(3,1,1,1)))
# ax1.plot(w,T_2,label="T_2",linestyle=(0,(3,1,1,1)))
# ax1.plot(w,T_3,label="T_3",linestyle=(0,(3,1,1,1)))
ax2.plot(w,T_1a,label="T_1a",linestyle=(0,(3,1,1,1)))
ax2.plot(w,T_2a,label="T_1b",linestyle=(0,(3,1,1,1)))
ax2.plot(w,T_2b,label="T_1c",linestyle=(0,(3,1,1,1)))
ax2.plot(w,T_2c,label="T_2",linestyle=(0,(3,1,1,1)))
ax2.plot(w,T_3a,label="T_3",linestyle=(0,(3,1,1,1)))

ax1.set_xlim(0,x_lim)
ax1.set_ylim(0,y_lim)
ax2.set_xlim(0,x_lim/ratio)
ax2.set_ylim(0,y_lim*ratio*r_eff)
ax3.set_xlim(0,x_lim)
ax3.set_ylim(0,p_lim+10)
ax4.set_ylim(0,100)
ax5.set_ylim(0,100)
ax6.set_ylim(0,100)

ax1.set_xlabel('n[rpm]')
ax1.set_ylabel('T_as[mNm]')
ax2.set_xlabel('n[rpm]')
ax2.set_ylabel('T_as[mNm]')
ax3.set_xlabel('n[rpm]')
ax3.set_ylabel('P[W]')
ax4.set_ylabel('%')
ax5.set_ylabel('%')
ax6.set_ylabel('%')

fig.tight_layout()

ax1.legend(loc='upper left')
ax2.legend(loc='upper left')
ax3.legend(loc='upper left')
ax4.legend(loc='upper right')
ax5.legend(loc='upper right')
ax6.legend(loc='upper right')


plt.show()
